//*******************************************************
//***
//***       Arithmetic Interpreter        Version 2.2
//***
//***                 C++ Version
//***
//*******************************************************

#ifndef __ARITHINTERPRETER__
#define __ARITHINTERPRETER__

#include <math.h>
#include <string.h>
#include <stdio.h>

#define PI 3.141592654
#define ESPACE_LARGEUR 50
#define ESPACE_HAUTEUR 20
#define HAUTEUR 15

class CPPNode {
  private:	
	
	protected:
		
		CPPNode * fg,* fd;
		
		float mValue;
		
		short mOperator;
	
	public:
	
		CPPNode(void);
		CPPNode(short,float,CPPNode * Fg=NULL,CPPNode * Fd=NULL);
		CPPNode(const CPPNode &);
		
		friend CPPNode * ConstructTree(char *,short,short &);
		float ComputeTree(float,float,short &);
		void WriteTree(char *);
		
		//Point Draw_Tree(Point &);         MacOSOnly
		//void DrawContent(Point);          MacOSOnly
		//short ObjetWidth(void);           MacOSOnly
		
		CPPNode & operator =(const CPPNode &);
		friend bool operator == (const CPPNode &,const CPPNode &);
		friend bool operator != (const CPPNode &,const CPPNode &);
};

char * CopyPartialString(char * inString,short inBegin,short inEnd);

float CalcValue(char * inString,short inIndex);
void FindOperator(short * oper,short * esp,char * inString,short pos);

#endif
